## simgear 2018.3.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.0)

if(COMMAND cmake_policy)
   if(POLICY CMP0054)
       cmake_policy(SET CMP0054 NEW)
   endif()
   if(POLICY CMP0042)
       cmake_policy(SET CMP0042 NEW)
   endif()
   if(POLICY CMP0067)
       cmake_policy(SET CMP0067 NEW)
   endif()
endif()


message(STATUS "CMAKE Build type: ${CMAKE_BUILD_TYPE}")
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo")
endif()

include (CheckFunctionExists)
include (CheckIncludeFile)
include (CheckLibraryExists)
include (CheckCXXSourceCompiles)
include (CheckCXXCompilerFlag)
include (GenerateExportHeader)

# only relevant for building shared libs but let's set it regardless
set(CMAKE_OSX_RPATH 1)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.9" CACHE STRING "Minimum OS X deployment version")

# let's use & require C++11 - note these are only functional with CMake 3.1
# we do manual fallbacks for CMake 3.0 in the compilers section
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED YES)

# read 'version' file into a variable (stripping any newlines or spaces)
file(READ version versionFile)
string(STRIP ${versionFile} SIMGEAR_VERSION)

project(SimGear VERSION ${SIMGEAR_VERSION} LANGUAGES C CXX)

# add a dependency on the version file
set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS version)

set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)

# use simgear version also as the SO version (if building SOs)
SET(SIMGEAR_SOVERSION ${SIMGEAR_VERSION})

# Warning when build is not an out-of-source build.
string(COMPARE EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_BINARY_DIR}" InSourceBuild)
if(InSourceBuild)
    message(WARNING  "Avoid building inside the source tree!")
    message(WARNING  "Create a separate build directory instead (i.e. 'sgbuild') and call CMake from there: ")
    message(WARNING  "  mkdir ../sgbuild && cd ../sgbuild && cmake ${CMAKE_SOURCE_DIR}")
endif(InSourceBuild)

#packaging
SET(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
SET(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Simulation support libraries for FlightGear and related projects")
SET(CPACK_PACKAGE_VENDOR "The FlightGear project")
SET(CPACK_GENERATOR "TBZ2")
SET(CPACK_INSTALL_CMAKE_PROJECTS  ${CMAKE_CURRENT_BINARY_DIR};SimGear;ALL;/)


# split version string into components, note CMAKE_MATCH_0 is the entire regexp match
string(REGEX MATCH "([0-9]+)\\.([0-9]+)\\.([0-9]+)" CPACK_PACKAGE_VERSION ${SIMGEAR_VERSION} )
set(CPACK_PACKAGE_VERSION_MAJOR ${CMAKE_MATCH_1})
set(CPACK_PACKAGE_VERSION_MINOR ${CMAKE_MATCH_2})
set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_MATCH_3})

message(STATUS "version is ${CPACK_PACKAGE_VERSION_MAJOR} dot ${CPACK_PACKAGE_VERSION_MINOR} dot ${CPACK_PACKAGE_VERSION_PATCH}")

set(CPACK_SOURCE_GENERATOR TBZ2)
set(CPACK_SOURCE_PACKAGE_FILE_NAME "simgear-${SIMGEAR_VERSION}" CACHE INTERNAL "tarball basename")
set(CPACK_SOURCE_IGNORE_FILES
  "^${PROJECT_SOURCE_DIR}/.git;\\\\.gitignore;Makefile.am;~$;${CPACK_SOURCE_IGNORE_FILES}")

include (CPack)

# We have some custom .cmake scripts not in the official distribution.
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

# Change the default build type to something fast
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)

# Determine name of library installation directory, i.e. "lib" vs "lib64", which
# differs between all Debian-based vs all other Linux distros.
# See cmake bug #11964, http://cmake.org/gitweb?p=cmake.git;a=commit;h=126c993d
include(GNUInstallDirs)
message(STATUS "Library installation directory: ${CMAKE_INSTALL_LIBDIR}")

#####################################################################################
# Configure library search paths
#####################################################################################

if (NOT MSVC)
option(SIMGEAR_SHARED   "Set to ON to build SimGear as a shared library/framework" OFF)
option(SYSTEM_EXPAT     "Set to ON to build SimGear using the system expat library" OFF)
option(SYSTEM_UDNS      "Set to ON to build SimGear using the system udns library" OFF)
else()
# Building SimGear DLLs is currently not supported for MSVC.
set(SIMGEAR_SHARED OFF)
# Using external 3rd party libraries is currently not supported for MSVC - it would require shared simgear (DLL).
set(SYSTEM_EXPAT OFF)
set(SYSTEM_UDNS OFF)
endif()

option(SIMGEAR_HEADLESS "Set to ON to build SimGear without GUI/graphics support" OFF)
option(ENABLE_RTI       "Set to ON to build SimGear with RTI support" OFF)
option(ENABLE_GDAL      "Set to ON to build SimGear with GDAL support" OFF)
option(ENABLE_TESTS     "Set to OFF to disable building SimGear's test applications" ON)
option(ENABLE_SOUND     "Set to OFF to disable building SimGear's sound support" ON)
option(USE_AEONWAVE     "Set to ON to use AeonWave instead of OpenAL" ON)
option(ENABLE_PKGUTIL   "Set to ON to build the sg_pkgutil application (default)" ON)
option(ENABLE_DNS       "Set to ON to use udns library and DNS service resolver" ON)
option(ENABLE_SIMD      "Enable SSE/SSE2 support for compilers" ON)
option(ENABLE_SIMD_CODE	"Enable SSE/SSE2 support code for compilers" OFF)
option(ENABLE_OPENMP    "Enable OpenMP compiler support" OFF)

if (NOT ENABLE_SIMD AND ENABLE_SIMD_CODE)
  set(ENABLE_SIMD_CODE OFF)
endif()

include (DetectArch)

# until the fstream fix is applied and generally available in OSG,
# keep the compatability link option as the default
option(OSG_FSTREAM_EXPORT_FIXED "Set to ON if the osgDB fstream export patch is applied" OFF)

if (CMAKE_COMPILER_IS_GNUCXX OR CLANG)
  if (CMAKE_VERSION VERSION_LESS 3.1)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++${CMAKE_CXX_STANDARD}")
  elseif (CMAKE_VERSION VERSION_LESS 3.8)
    # policy CMP0067 (try_compile does not honor CMAKE_CXX_STANDARD)
    set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -std=c++${CMAKE_CXX_STANDARD}")
  endif()
endif()


if (MSVC)
  GET_FILENAME_COMPONENT(PARENT_DIR ${PROJECT_BINARY_DIR} PATH)
  if (CMAKE_CL_64)
    SET(TEST_3RDPARTY_DIR "${PARENT_DIR}/3rdparty.x64")
  else (CMAKE_CL_64)
    SET(TEST_3RDPARTY_DIR "${PARENT_DIR}/3rdparty")
  endif (CMAKE_CL_64)
  if (EXISTS ${TEST_3RDPARTY_DIR})
    set(MSVC_3RDPARTY_ROOT ${PARENT_DIR} CACHE PATH "Location where the third-party dependencies are extracted")
  else (EXISTS ${TEST_3RDPARTY_DIR})
    set(MSVC_3RDPARTY_ROOT NOT_FOUND CACHE PATH "Location where the third-party dependencies are extracted")
  endif (EXISTS ${TEST_3RDPARTY_DIR})
else (MSVC)
  set(MSVC_3RDPARTY_ROOT NOT_FOUND CACHE PATH "Location where the third-party dependencies are extracted")
endif (MSVC)

if (MSVC AND MSVC_3RDPARTY_ROOT)
  message(STATUS "3rdparty files located in ${MSVC_3RDPARTY_ROOT}")

  string(SUBSTRING ${MSVC_VERSION} 0 2 MSVC_VERSION_MAJOR)
  string(SUBSTRING ${MSVC_VERSION} 2 2 MSVC_VERSION_MINOR)

  set( OSG_MSVC "msvc" )
  if (${MSVC_VERSION_MAJOR} EQUAL "19")
    if (${MSVC_VERSION_MINOR} EQUAL "00")
      set( OSG_MSVC ${OSG_MSVC}140 )
    else ()
      set( OSG_MSVC ${OSG_MSVC}141 )
    endif ()
  elseif (${MSVC_VERSION_MAJOR} EQUAL "18")
    set( OSG_MSVC ${OSG_MSVC}120 )
  else ()
    message(FATAL_ERROR "Visual Studio 2013/15/17 is required")
  endif ()

  if (CMAKE_CL_64)
      set( OSG_MSVC ${OSG_MSVC}-64 )
      set( MSVC_3RDPARTY_DIR 3rdParty.x64 )
  else (CMAKE_CL_64)
      set( MSVC_3RDPARTY_DIR 3rdParty )
  endif (CMAKE_CL_64)

  set (CMAKE_LIBRARY_PATH ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/lib ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/OpenScenegraph/lib ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/OpenRTI/lib )
  set (CMAKE_INCLUDE_PATH ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/include ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/OpenScenegraph/include ${MSVC_3RDPARTY_ROOT}/install/${OSG_MSVC}/OpenRTI/include)

  if(NOT BOOST_INCLUDEDIR)
    # if this variable was not set by the user, set it to 3rdparty root's
    # parent dir, which is the normal location for people using our
    # windows-3rd-party repo
    GET_FILENAME_COMPONENT(MSVC_ROOT_PARENT_DIR ${MSVC_3RDPARTY_ROOT} PATH)
    set(BOOST_INCLUDEDIR ${MSVC_ROOT_PARENT_DIR})
    message(STATUS "BOOST_INCLUDEDIR is ${BOOST_INCLUDEDIR}")
  endif()

  set (OPENAL_INCLUDE_DIR ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/include)
  set (OPENAL_LIBRARY_DIR ${MSVC_3RDPARTY_ROOT}/${MSVC_3RDPARTY_DIR}/lib)
endif (MSVC AND MSVC_3RDPARTY_ROOT)

if(APPLE)
  find_library(COCOA_LIBRARY Cocoa)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR ${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    find_package(Threads REQUIRED)
endif()

find_package(Boost REQUIRED)
set (BOOST_CXX_FLAGS "-DBOOST_BIMAP_DISABLE_SERIALIZATION")
include(BoostTestTargets)

if(SIMGEAR_HEADLESS)
    message(STATUS "SimGear mode: HEADLESS")
    set(ENABLE_SOUND 0)
else()
    message(STATUS "SimGear mode: NORMAL")
    find_package(OpenGL REQUIRED)

    if (ENABLE_SOUND)
        if (USE_AEONWAVE)
            find_package(AAX)
        endif()

        if(NOT AAX_FOUND)
            set(USE_AEONWAVE FALSE)
            find_package(OpenAL REQUIRED)
        endif()

        if(AAX_FOUND)
            message(STATUS "Sound support: AeonWave")
        else()
            message(STATUS "Sound support: OpenAL")
        endif()
    endif(ENABLE_SOUND)

    find_package(OpenSceneGraph 3.2.0 REQUIRED osgText osgSim osgDB osgParticle osgGA osgViewer osgUtil)

    if (MSVC)
      set(CMAKE_REQUIRED_INCLUDES ${OPENSCENEGRAPH_INCLUDE_DIRS})
      # ensure OSG was compiled with OSG_USE_UTF8_FILENAME set
      check_cxx_source_compiles(
         "#include <osg/Config>
         #if !defined(OSG_USE_UTF8_FILENAME)
          #error OSG UTF8 support not enabled
         #endif
         int main() { return 0; }"
         SIMGEAR_OSG_USE_UTF8_FILENAME)
      if (NOT SIMGEAR_OSG_USE_UTF8_FILENAME)
        message(FATAL_ERROR "Please rebuild OSG with OSG_USE_UTF8_FILENAME set to ON")
      endif()
    endif()
endif(SIMGEAR_HEADLESS)

find_package(ZLIB 1.2.4 REQUIRED)
find_package(CURL REQUIRED)

if (SYSTEM_EXPAT)
    message(STATUS "Requested to use system Expat library, forcing SIMGEAR_SHARED to true")
    set(SIMGEAR_SHARED ON)
    find_package(EXPAT REQUIRED)

else()
    message(STATUS "Using built-in expat code")
    # XML_STATIC is important to avoid sg_expat_external.h
    # declaring symbols as declspec(import)
    add_definitions(-DHAVE_EXPAT_CONFIG_H -DXML_STATIC)
    set(EXPAT_INCLUDE_DIRS
            ${PROJECT_SOURCE_DIR}/3rdparty/expat
            ${PROJECT_BINARY_DIR}/3rdparty/expat)
endif(SYSTEM_EXPAT)

check_include_file(inttypes.h HAVE_INTTYPES_H)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(unistd.h HAVE_UNISTD_H)
check_include_file(windows.h HAVE_WINDOWS_H)

if(HAVE_INTTYPES_H)
  # ShivaVG needs inttypes.h
  add_definitions(-DHAVE_INTTYPES_H)
endif()

if(ENABLE_RTI)
    find_package(PkgConfig)
    if(PKG_CONFIG_FOUND)
      SET(ENV{PKG_CONFIG_PATH} "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}")
      pkg_check_modules(RTI hla-rti13)
    endif(PKG_CONFIG_FOUND)
    if(RTI_FOUND)
      SET(RTI_INCLUDE_DIR "${RTI_INCLUDE_DIRS}")
      message(STATUS "RTI: ENABLED")
    else()
      message(STATUS "RTI: DISABLED")
    endif(RTI_FOUND)
else()
    message(STATUS "RTI: DISABLED")
endif(ENABLE_RTI)

if(ENABLE_GDAL)
    find_package(GDAL 2.0.0 REQUIRED)
    if (GDAL_FOUND)
        include_directories(${GDAL_INCLUDE_DIR})
    endif(GDAL_FOUND)
endif(ENABLE_GDAL)

check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)

=== simgear/io/CMakeLists.txt ===
add_subdirectory(iostreams)

include (SimGearComponent)

set(HEADERS
    iochannel.hxx
    lowlevel.hxx
    raw_socket.hxx
    sg_binobj.hxx
    sg_file.hxx
    sg_netBuffer.hxx
    sg_netChannel.hxx
    sg_netChat.hxx
    sg_serial.hxx
    sg_socket.hxx
    sg_socket_udp.hxx
    HTTPClient.hxx
    HTTPFileRequest.hxx
    HTTPMemoryRequest.hxx
    HTTPRequest.hxx
    HTTPRepository.hxx
    untar.hxx
    )

set(SOURCES
    iochannel.cxx
    lowlevel.cxx
    raw_socket.cxx
    sg_binobj.cxx
    sg_file.cxx
    sg_netBuffer.cxx
    sg_netChannel.cxx
    sg_netChat.cxx
    sg_serial.cxx
    sg_socket.cxx
    sg_socket_udp.cxx
    HTTPClient.cxx
    HTTPFileRequest.cxx
    HTTPMemoryRequest.cxx
    HTTPRequest.cxx
    HTTPRepository.cxx
    untar.cxx
    )

if(ENABLE_DNS)
  list(APPEND SOURCES DNSClient.cxx)
  list(APPEND HEADERS DNSClient.hxx)
endif()

simgear_component(io io "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS)

add_executable(test_sock socktest.cxx)
target_link_libraries(test_sock ${TEST_LIBS})

add_executable(test_http test_HTTP.cxx)
target_link_libraries(test_http ${TEST_LIBS})

add_test(http ${EXECUTABLE_OUTPUT_PATH}/test_http)

if(ENABLE_DNS)
	add_executable(test_dns test_DNS.cxx)
	target_link_libraries(test_dns ${TEST_LIBS})
	add_test(dns ${EXECUTABLE_OUTPUT_PATH}/test_dns)
endif()

add_executable(httpget httpget.cxx)
target_link_libraries(httpget ${TEST_LIBS})

add_executable(http_repo_sync http_repo_sync.cxx)
target_link_libraries(http_repo_sync ${TEST_LIBS})

add_executable(decode_binobj decode_binobj.cxx)
target_link_libraries(decode_binobj ${TEST_LIBS})

add_executable(test_binobj test_binobj.cxx)
target_link_libraries(test_binobj ${TEST_LIBS})

add_test(binobj ${EXECUTABLE_OUTPUT_PATH}/test_binobj)

add_executable(test_repository test_repository.cxx)
target_link_libraries(test_repository ${TEST_LIBS})
add_test(http_repository ${EXECUTABLE_OUTPUT_PATH}/test_repository)

add_executable(test_untar test_untar.cxx)

set_target_properties(test_untar PROPERTIES
  COMPILE_DEFINITIONS "SRC_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"" )

target_link_libraries(test_untar ${TEST_LIBS})
add_test(untar ${EXECUTABLE_OUTPUT_PATH}/test_untar)

endif(ENABLE_TESTS)

=== simgear/structure/CMakeLists.txt ===

include (SimGearComponent)

set(HEADERS
    OSGUtils.hxx
    OSGVersion.hxx
    SGAtomic.hxx
    SGBinding.hxx
    SGExpression.hxx
    SGReferenced.hxx
    SGSharedPtr.hxx
    SGSmplhist.hxx
    SGSmplstat.hxx
    SGWeakPtr.hxx
    SGWeakReferenced.hxx
    SGPerfMon.hxx
    singleton.hpp
    Singleton.hxx
    StringTable.hxx
    callback.hxx
    commands.hxx
    event_mgr.hxx
    exception.hxx
    function_list.hxx
    intern.hxx
    map.hxx
    subsystem_mgr.hxx
    StateMachine.hxx
    )

set(SOURCES
    SGAtomic.cxx
    SGBinding.cxx
    SGExpression.cxx
    SGSmplhist.cxx
    SGSmplstat.cxx
    SGPerfMon.cxx
    StringTable.cxx
    commands.cxx
    event_mgr.cxx
    exception.cxx
    subsystem_mgr.cxx 
    StateMachine.cxx
    )

simgear_component(structure structure "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS)

add_executable(test_subsystems subsystem_test.cxx)
target_link_libraries(test_subsystems ${TEST_LIBS})
add_test(subsystems ${EXECUTABLE_OUTPUT_PATH}/test_subsystems)

add_executable(test_state_machine state_machine_test.cxx)
target_link_libraries(test_state_machine ${TEST_LIBS})
add_test(state_machine ${EXECUTABLE_OUTPUT_PATH}/test_state_machine)

add_executable(test_expressions expression_test.cxx)
target_link_libraries(test_expressions ${TEST_LIBS})
add_test(expressions ${EXECUTABLE_OUTPUT_PATH}/test_expressions)

add_executable(test_shared_ptr shared_ptr_test.cpp)
target_link_libraries(test_shared_ptr ${TEST_LIBS})
add_test(shared_ptr ${EXECUTABLE_OUTPUT_PATH}/test_shared_ptr)

endif(ENABLE_TESTS)

add_boost_test(function_list
  SOURCES function_list_test.cxx
  LIBRARIES ${TEST_LIBS}
)

=== simgear/nasal/cppbind/CMakeLists.txt ===
include (SimGearComponent)

set(HEADERS
  cppbind_fwd.hxx
  Ghost.hxx
  NasalCallContext.hxx
  NasalContext.hxx
  NasalHash.hxx
  NasalMe.hxx
  NasalMethodHolder.hxx
  NasalObject.hxx
  NasalObjectHolder.hxx
  NasalString.hxx
  from_nasal.hxx
  to_nasal.hxx
)

set(DETAIL_HEADERS
  detail/from_nasal_helper.hxx
  detail/nasal_traits.hxx
  detail/to_nasal_helper.hxx
)

set(SOURCES
  Ghost.cxx
  NasalContext.cxx
  NasalHash.cxx
  NasalString.cxx
  NasalObject.cxx
  detail/from_nasal_helper.cxx
  detail/to_nasal_helper.cxx
)

simgear_component(nasal/cppbind nasal/cppbind "${SOURCES}" "${HEADERS}")
simgear_component(nasal/cppbind/detail nasal/cppbind/detail "" "${DETAIL_HEADERS}")

add_boost_test(cppbind_ghost
  SOURCES test/cppbind_test_ghost.cxx
  LIBRARIES ${TEST_LIBS}
)

add_boost_test(cppbind_misc
  SOURCES test/cppbind_test.cxx
  LIBRARIES ${TEST_LIBS}
)

add_boost_test(nasal_gc_test
  SOURCES test/nasal_gc_test.cxx
  LIBRARIES ${TEST_LIBS}
)

add_boost_test(nasal_num
  SOURCES test/nasal_num_test.cxx
  LIBRARIES ${TEST_LIBS}
)

=== simgear/scene/sky/CMakeLists.txt ===
include (SimGearComponent)

set(HEADERS 
    CloudShaderGeometry.hxx
    cloud.hxx
    cloudfield.hxx
    dome.hxx
    moon.hxx
    newcloud.hxx
    oursun.hxx
    sky.hxx
    sphere.hxx
    stars.hxx
    )

set(SOURCES 
    CloudShaderGeometry.cxx
    cloud.cxx
    cloudfield.cxx
    dome.cxx
    moon.cxx
    newcloud.cxx
    oursun.cxx
    sky.cxx
    sphere.cxx
    stars.cxx
    )

simgear_scene_component(sky scene/sky "${SOURCES}" "${HEADERS}")

=== simgear/scene/util/CMakeLists.txt ===
include (SimGearComponent)

set(HEADERS
    ColorInterpolator.hxx
    CopyOp.hxx
    DeletionManager.hxx
    NodeAndDrawableVisitor.hxx
    Noise.hxx
    OptionsReadFileCallback.hxx
    OsgDebug.hxx
    OsgMath.hxx
    OsgSingleton.hxx
    parse_color.hxx
    PrimitiveUtils.hxx
    QuadTreeBuilder.hxx
    RenderConstants.hxx
    SGDebugDrawCallback.hxx
    SGEnlargeBoundingBox.hxx
    SGNodeMasks.hxx
    SGPickCallback.hxx
    SGReaderWriterOptions.hxx
    SGSceneFeatures.hxx
    SGSceneUserData.hxx
    SGStateAttributeVisitor.hxx
    SGTextureStateAttributeVisitor.hxx
    SGTransientModelData.hxx
    SGUpdateVisitor.hxx
    SplicingVisitor.hxx
    StateAttributeFactory.hxx
    UpdateOnceCallback.hxx
    VectorArrayAdapter.hxx
    project.hxx
    )

set(SOURCES
    ColorInterpolator.cxx
    CopyOp.cxx
    DeletionManager.cxx
    NodeAndDrawableVisitor.cxx
    Noise.cxx
    OptionsReadFileCallback.cxx
    OsgDebug.cxx
    parse_color.cxx
    PrimitiveUtils.cxx
    QuadTreeBuilder.cxx
    SGEnlargeBoundingBox.cxx
    SGReaderWriterOptions.cxx
    SGSceneFeatures.cxx
    SGSceneUserData.cxx
    SGStateAttributeVisitor.cxx
    SGTextureStateAttributeVisitor.cxx
    SplicingVisitor.cxx
    StateAttributeFactory.cxx
    UpdateOnceCallback.cxx
    project.cxx
    )

simgear_scene_component(util scene/util "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS)

add_executable(test_parse_color parse_color_test.cxx )
add_test(parse_color ${EXECUTABLE_OUTPUT_PATH}/test_parse_color)
target_link_libraries(test_parse_color ${TEST_LIBS})

endif(ENABLE_TESTS)

=== debian/changelog ===
simgear (1:2018.3.2+dfsg-5) unstable; urgency=medium

  * Fix HTTP redirect handling.
    Otherwise, the live weather feature in flightgear will not work.
    Both patches are cherry-picks from upstream's git repository.
    (Closes: #921598)

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 17 Feb 2019 20:29:06 +0100

simgear (1:2018.3.2+dfsg-4) unstable; urgency=medium

  * Add necessary #includes for the patch ...

 -- Dr. Tobias Quathamer <toddy@debian.org>  Mon, 04 Feb 2019 14:15:59 +0100

simgear (1:2018.3.2+dfsg-3) unstable; urgency=medium

  * Rewrite patch so that it gets actually applied on armel and armhf

 -- Dr. Tobias Quathamer <toddy@debian.org>  Mon, 04 Feb 2019 12:58:25 +0100

simgear (1:2018.3.2+dfsg-2) unstable; urgency=medium

  * Add new patch to fix FTBFS on armel and armhf

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 03 Feb 2019 17:19:01 +0100

simgear (1:2018.3.2+dfsg-1) unstable; urgency=medium

  * New upstream version 2018.3.2+dfsg
    - Refresh patches
  * Use debhelper-compat (= 12)
  * Update to Standards-Version to 4.3.0, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 02 Feb 2019 00:19:04 +0100

=== debian/control ===
Source: simgear
Section: libs
Priority: optional
Maintainer: Debian FlightGear Crew <team+flightgear@tracker.debian.org>
Uploaders: Ove Kaaven <ovek@arcticnet.no>,
           Markus Wanner <markus@bluegap.ch>,
           Dr. Tobias Quathamer <toddy@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               libboost-dev,
               libcurl4-gnutls-dev,
               libexpat1-dev,
               libgl1-mesa-dev,
               libglu1-mesa-dev,
               libopenal-dev,
               libopenscenegraph-3.4-dev [!armel !armhf],
               libopenscenegraph-dev (>= 3.2.0~) [armel armhf],
               libudns-dev,
               libutfcpp-dev,
               netbase,
               zlib1g-dev
Standards-Version: 4.3.0
Homepage: https://home.flightgear.org/
Vcs-Browser: https://salsa.debian.org/debian/simgear
Vcs-Git: https://salsa.debian.org/debian/simgear.git

Package: libsimgear-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libc6-dev,
         libopenscenegraph-3.4-dev [!armel !armhf],
         libopenscenegraph-dev [armel armhf],
         ${misc:Depends}
Replaces: simgear-dev (<< 2.10.0~)
Breaks: simgear-dev (<< 2.10.0~)
Description: Simulator Construction Gear -- development files
 SimGear is a collection of libraries useful for constructing
 simulation and visualization applications such as FlightGear
 or TerraGear.
 .
 This package contains the headers and static libraries.

## simgear 2019.1.1%2Bdfsg

=== simgear/CMakeLists.txt ===

file(WRITE ${PROJECT_BINARY_DIR}/simgear/version.h "#define SIMGEAR_VERSION ${SIMGEAR_VERSION}")

foreach( mylibfolder
        bucket
        bvh
        debug
        embedded_resources
        ephemeris
        io
        magvar
        math
        misc
        nasal
        nasal/cppbind
        props
        serial
        std
        structure
        threads
        timing
        xml
        package
    )

    add_subdirectory(${mylibfolder})

endforeach( mylibfolder )

if(NOT SIMGEAR_HEADLESS)
    add_subdirectory(canvas)
    add_subdirectory(environment)
    add_subdirectory(screen)
    add_subdirectory(scene)
    add_subdirectory(sound)
endif(NOT SIMGEAR_HEADLESS)


if(ENABLE_RTI)
    add_subdirectory(hla)
endif(ENABLE_RTI)


set(HEADERS compiler.h constants.h sg_inlines.h ${PROJECT_BINARY_DIR}/simgear/version.h)
install (FILES ${HEADERS}  DESTINATION include/simgear/)

get_property(coreSources GLOBAL PROPERTY CORE_SOURCES)
get_property(sceneSources GLOBAL PROPERTY SCENE_SOURCES)
get_property(publicHeaders GLOBAL PROPERTY PUBLIC_HEADERS)
get_property(localExpatSources GLOBAL PROPERTY LOCAL_EXPAT_SOURCES)

if(SIMGEAR_SHARED)
    message(STATUS "Library building mode: SHARED LIBRARIES")
    add_library(SimGearCore SHARED ${coreSources} ${localExpatSources})

    set_property(TARGET SimGearCore PROPERTY LINKER_LANGUAGE CXX)
    set_property(TARGET SimGearCore PROPERTY VERSION   ${SIMGEAR_VERSION})
    set_property(TARGET SimGearCore PROPERTY SOVERSION ${SIMGEAR_SOVERSION})


    if(NOT SIMGEAR_HEADLESS)
        add_library(SimGearScene SHARED ${sceneSources})
        set_property(TARGET SimGearScene PROPERTY LINKER_LANGUAGE CXX)
        set_property(TARGET SimGearScene PROPERTY VERSION   ${SIMGEAR_VERSION})
        set_property(TARGET SimGearScene PROPERTY SOVERSION ${SIMGEAR_SOVERSION})
    endif()
else()
    message(STATUS "Library building mode: STATIC LIBRARIES")

	get_property(FG_GROUPS_CORE_SOURCES_C GLOBAL PROPERTY FG_GROUPS_CORE_SOURCES_C)
	string(REPLACE "@" ";" groups ${FG_GROUPS_CORE_SOURCES_C} )
	foreach(g ${groups})
		string(REPLACE "#" ";" g2 ${g})
		list(GET g2 0 name)
		list(REMOVE_AT g2 0)
		source_group("${name}\\Sources" FILES ${g2})
	endforeach()

	get_property(FG_GROUPS_CORE_SOURCES_H GLOBAL PROPERTY FG_GROUPS_CORE_SOURCES_H)
	string(REPLACE "@" ";" groups ${FG_GROUPS_CORE_SOURCES_H} )
	foreach(g ${groups})
		string(REPLACE "#" ";" g2 ${g})
		list(GET g2 0 name)
		list(REMOVE_AT g2 0)
		source_group("${name}\\Headers" FILES ${g2})
	endforeach()

    add_library(SimGearCore STATIC ${coreSources} ${localExpatSources})

    if(NOT SIMGEAR_HEADLESS)
		get_property(FG_GROUPS_SCENE_SOURCES_C GLOBAL PROPERTY FG_GROUPS_SCENE_SOURCES_C)
		string(REPLACE "@" ";" groups ${FG_GROUPS_SCENE_SOURCES_C} )
		foreach(g ${groups})
			string(REPLACE "#" ";" g2 ${g})
			list(GET g2 0 name)
			list(REMOVE_AT g2 0)
			source_group("${name}\\Sources" FILES ${g2})
		endforeach()

		get_property(FG_GROUPS_SCENE_SOURCES_H GLOBAL PROPERTY FG_GROUPS_SCENE_SOURCES_H)
		string(REPLACE "@" ";" groups ${FG_GROUPS_SCENE_SOURCES_H} )
		foreach(g ${groups})
			string(REPLACE "#" ";" g2 ${g})
			list(GET g2 0 name)
			list(REMOVE_AT g2 0)
			source_group("${name}\\Headers" FILES ${g2})
		endforeach()

        add_library(SimGearScene STATIC ${sceneSources})
    endif(NOT SIMGEAR_HEADLESS)
endif(SIMGEAR_SHARED)

target_include_directories(SimGearCore BEFORE PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>)

target_include_directories(SimGearCore PUBLIC
  ${Boost_INCLUDE_DIRS} ${ZLIB_INCLUDE_DIR})
target_include_directories(SimGearCore PRIVATE
  ${EXPAT_INCLUDE_DIRS} ${CURL_INCLUDE_DIRS})

    install(TARGETS SimGearCore
            EXPORT SimGearTargets
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

if (NOT SIMGEAR_HEADLESS)
  install(TARGETS SimGearScene
          EXPORT SimGearTargets
          LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

  target_include_directories(SimGearScene BEFORE PUBLIC
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>)

    target_include_directories(SimGearScene PUBLIC ${OPENSCENEGRAPH_INCLUDE_DIRS})

    if (USE_AEONWAVE)
      target_include_directories(SimGearScene PRIVATE ${AAX_INCLUDE_DIR} )
    else()
      target_include_directories(SimGearScene PRIVATE ${OPENAL_INCLUDE_DIR} )
    endif()
endif()


target_link_libraries(SimGearCore
    ${ZLIB_LIBRARY}
    ${RT_LIBRARY}
    ${DL_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT}
    ${COCOA_LIBRARY}
    ${CURL_LIBRARIES}
    ${WINSOCK_LIBRARY})

if(SYSTEM_EXPAT)
    target_link_libraries(SimGearCore
        ${EXPAT_LIBRARIES})
endif()

if(ENABLE_DNS AND SYSTEM_UDNS)
    target_link_libraries(SimGearCore
        ${UDNS_LIBRARIES})
endif()

if(NOT SIMGEAR_HEADLESS)
    target_include_directories(SimGearScene PRIVATE ${PROJECT_SOURCE_DIR}/simgear/canvas/ShivaVG/include)

    target_link_libraries(SimGearScene
        SimGearCore
        ${ZLIB_LIBRARY}
        ${OPENSCENEGRAPH_LIBRARIES}
        ${OPENAL_LIBRARY}
        ${OPENGL_LIBRARY}
        ${JPEG_LIBRARY})

    if(ENABLE_GDAL)
        target_link_libraries(SimGearScene
            ${GDAL_LIBRARIES})
    endif()

    # only actually needed by canvas/KeyboardEvent.cxx
    target_include_directories(SimGearScene PRIVATE ${PROJECT_SOURCE_DIR}/3rdparty/utf8/source)
endif()

if(ENABLE_RTI)
    # Ugly first aid to make hla compile agian
    set_property(SOURCE hla/RTI13InteractionClass.cxx hla/RTI13ObjectClass.cxx
        hla/RTI13ObjectInstance.cxx hla/RTI13Federate.cxx
        hla/RTI13FederateFactory.cxx
        APPEND PROPERTY COMPILE_FLAGS "-I${RTI_INCLUDE_DIR}")
endif(ENABLE_RTI)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# debian/rules for simgear, by Markus Wanner
# based on the dh7 template provided by dh_make(1)

# Include makefile snippet for DEB_HOST_ARCH
include /usr/share/dpkg/architecture.mk

# Enable all hardening options
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# http://wiki.debian.org/Hardening#Notes_for_packages_using_CMake
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
ifneq (,$(findstring $(DEB_HOST_ARCH) , amd64 i386 mipsel ia64 armel armhf arm64 ))

# Note the spaces in the condition above. They stop 'mips' from
# matching 'mipsel'
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
else

# Required on big-endian architectures, see bug #722115
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS) -fno-strict-aliasing
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS) -fno-strict-aliasing
endif
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE="RelWithDebInfo" \
	-DCMAKE_C_FLAGS="$(CFLAGS)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
	-DCMAKE_CXX_FLAGS_RELWITHDEBINFO="-g -DNDEBUG" \
	-DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)" \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_INSTALL_PREFIX:PATH=/usr \
	-DSIMGEAR_SHARED=OFF \
	-DSYSTEM_EXPAT=ON \
	-DSYSTEM_UDNS=ON \
	-DENABLE_DNS=ON

%:
	dh $@ --buildsystem=cmake --builddirectory=build

override_dh_auto_configure:
	mkdir build
	cd build && cmake .. $(CMAKE_FLAGS)

override_dh_clean:
	dh_clean
	rm -rf CMakeFiles

override_dh_auto_test:
		dh_auto_test --no-parallel

get-orig-source:
	uscan --download-current-version --verbose --rename

## simgear 2019.1.1+dfsg

=== simgear/debug/CMakeLists.txt ===

include (SimGearComponent)

set(HEADERS debug_types.h logstream.hxx BufferedLogCallback.hxx OsgIoCapture.hxx)
set(SOURCES logstream.cxx BufferedLogCallback.cxx)

simgear_component(debug debug "${SOURCES}" "${HEADERS}")

=== simgear/std/CMakeLists.txt ===
include (SimGearComponent)

set(HEADERS
  integer_sequence.hxx
  type_traits.hxx
)

set(SOURCES
)

simgear_component(std std "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS)
  add_executable(test_integer_sequence integer_sequence_test.cxx)
  add_test(integer_sequence ${EXECUTABLE_OUTPUT_PATH}/test_integer_sequence)
  target_link_libraries(test_integer_sequence ${TEST_LIBS})

  add_executable(test_type_traits type_traits_test.cxx)
  add_test(type_traits ${EXECUTABLE_OUTPUT_PATH}/test_type_traits)
  target_link_libraries(test_type_traits ${TEST_LIBS})
endif()

=== simgear/scene/util/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,7 @@
     RenderConstants.hxx
     SGDebugDrawCallback.hxx
     SGEnlargeBoundingBox.hxx
+    SGImageUtils.hxx
     SGNodeMasks.hxx
     SGPickCallback.hxx
     SGReaderWriterOptions.hxx
@@ -44,6 +45,7 @@
     PrimitiveUtils.cxx
     QuadTreeBuilder.cxx
     SGEnlargeBoundingBox.cxx
+    SGImageUtils.cxx
     SGReaderWriterOptions.cxx
     SGSceneFeatures.cxx
     SGSceneUserData.cxx

=== simgear/scene/viewer/CMakeLists.txt ===
set(HEADERS
  ClusteredForward.hxx
  Compositor.hxx
  CompositorBuffer.hxx
  CompositorPass.hxx
  CompositorUtil.hxx
  )

set(SOURCES
  ClusteredForward.cxx
  Compositor.cxx
  CompositorBuffer.cxx
  CompositorPass.cxx
  CompositorUtil.cxx
  )

simgear_scene_component(viewer scene/viewer "${SOURCES}" "${HEADERS}")

=== debian/changelog ===
simgear (1:2019.1.1+dfsg-3ubuntu0.1~esm1) focal-security; urgency=medium

  * SECURITY UPDATE: Arbitrary code execution
    - debian/patches/CVE-2025-0781.patch: Remove the from_nasal_helper()
      for SGPath
    - CVE-2025-0781
  * debian/rules: Fix FTBFS due to boost tests by skipping tests with 
    -DENABLE_TESTS=OFF

 -- John Breton <john.breton@canonical.com>  Tue, 13 Jan 2026 14:30:47 -0500

simgear (1:2019.1.1+dfsg-3) unstable; urgency=medium

  * Team upload

  [ Alberto Luaces <aluaces@udc.es> ]
  * Use the main openscenegraph instead of old openscenegraph-3.4, scheduled
    for removal (Closes: #944526)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 14 Nov 2019 09:01:57 +0100

simgear (1:2019.1.1+dfsg-2) unstable; urgency=medium

  * Add patch to fix another FTBFS on armel and armhf

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 10 Aug 2019 13:18:49 +0200

simgear (1:2019.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version 2019.1.1+dfsg
    - Drop three patches that have been applied upstream
    - Refresh remaining patches
  * Update to Standards-Version 4.4.0, no changes needed
  * Remove obsolete Replaces and Breaks
  * Remove obsolete versioned Build-Depends
  * Rename License shortkey in d/copyright from MIT to Expat
  * Update d/copyright
  * Apply remaining fixes from cme fix dpkg

 -- Dr. Tobias Quathamer <toddy@debian.org>  Fri, 09 Aug 2019 17:43:54 +0200

=== debian/control ===
Source: simgear
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian FlightGear Crew <team+flightgear@tracker.debian.org>
Uploaders: Ove Kaaven <ovek@arcticnet.no>,
           Markus Wanner <markus@bluegap.ch>,
           Dr. Tobias Quathamer <toddy@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               libboost-dev,
               libcurl4-gnutls-dev,
               libexpat1-dev,
               libgl1-mesa-dev,
               libglu1-mesa-dev,
               libopenal-dev,
               libopenscenegraph-dev,
               libudns-dev,
               libutfcpp-dev,
               netbase,
               zlib1g-dev
Standards-Version: 4.4.0
Homepage: https://home.flightgear.org/
Vcs-Browser: https://salsa.debian.org/debian/simgear
Vcs-Git: https://salsa.debian.org/debian/simgear.git

Package: libsimgear-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libc6-dev,
         libopenscenegraph-dev,
         ${misc:Depends}
Description: Simulator Construction Gear -- development files
 SimGear is a collection of libraries useful for constructing
 simulation and visualization applications such as FlightGear
 or TerraGear.
 .
 This package contains the headers and static libraries.

=== debian/rules ===
--- 
+++ 
@@ -28,8 +28,8 @@
 
 CMAKE_FLAGS = \
 	-DCMAKE_BUILD_TYPE="RelWithDebInfo" \
-	-DCMAKE_C_FLAGS="$(CFLAGS)" \
-	-DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
+	-DCMAKE_C_FLAGS="$(CFLAGS) -I$(CURDIR)/build" \
+	-DCMAKE_CXX_FLAGS="$(CXXFLAGS) -I$(CURDIR)/build" \
 	-DCMAKE_CXX_FLAGS_RELWITHDEBINFO="-g -DNDEBUG" \
 	-DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)" \
 	-DCMAKE_VERBOSE_MAKEFILE=ON \
@@ -37,7 +37,8 @@
 	-DSIMGEAR_SHARED=OFF \
 	-DSYSTEM_EXPAT=ON \
 	-DSYSTEM_UDNS=ON \
-	-DENABLE_DNS=ON
+	-DENABLE_DNS=ON \
+	-DENABLE_TESTS=OFF
 
 %:
 	dh $@ --buildsystem=cmake --builddirectory=build

## simgear 2020.1.2+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,9 @@
    endif()
    if(POLICY CMP0067)
        cmake_policy(SET CMP0067 NEW)
+   endif()
+   if(POLICY CMP0093)
+       cmake_policy(SET CMP0093 NEW)
    endif()
 endif()
 
@@ -134,6 +137,7 @@
 endif()
 
 include (DetectArch)
+include (ExportDebugSymbols)
 
 # until the fstream fix is applied and generally available in OSG,
 # keep the compatability link option as the default
@@ -150,7 +154,7 @@
 
 
 if (MSVC)
-  GET_FILENAME_COMPONENT(PARENT_DIR ${PROJECT_BINARY_DIR} PATH)
+  GET_FILENAME_COMPONENT(PARENT_DIR ${PROJECT_BINARY_DIR} DIRECTORY)
   if (CMAKE_CL_64)
     SET(TEST_3RDPARTY_DIR "${PARENT_DIR}/3rdparty.x64")
   else (CMAKE_CL_64)
@@ -161,6 +165,11 @@
   else (EXISTS ${TEST_3RDPARTY_DIR})
     set(MSVC_3RDPARTY_ROOT NOT_FOUND CACHE PATH "Location where the third-party dependencies are extracted")
   endif (EXISTS ${TEST_3RDPARTY_DIR})
+
+  # override CMake default RelWithDebInfo flags. This is important to ensure
+  # good performance
+  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "/Zi /O2 /Ob2 /D NDEBUG")
+  set(CMAKE_C_FLAGS_RELWITHDEBINFO "/Zi /O2 /Ob2 /D NDEBUG")
 else (MSVC)
   set(MSVC_3RDPARTY_ROOT NOT_FOUND CACHE PATH "Location where the third-party dependencies are extracted")
 endif (MSVC)
@@ -173,15 +182,17 @@
 
   set( OSG_MSVC "msvc" )
   if (${MSVC_VERSION_MAJOR} EQUAL "19")
-    if (${MSVC_VERSION_MINOR} EQUAL "00")
+    if (${MSVC_VERSION_MINOR} GREATER_EQUAL "20")
+      set( OSG_MSVC ${OSG_MSVC}142 )
+    elseif (${MSVC_VERSION_MINOR} GREATER_EQUAL "10")
+      set( OSG_MSVC ${OSG_MSVC}141 )
+    else ()
       set( OSG_MSVC ${OSG_MSVC}140 )
-    else ()
-      set( OSG_MSVC ${OSG_MSVC}141 )
     endif ()
   elseif (${MSVC_VERSION_MAJOR} EQUAL "18")
     set( OSG_MSVC ${OSG_MSVC}120 )
   else ()
-    message(FATAL_ERROR "Visual Studio 2013/15/17 is required")
+    message(FATAL_ERROR "Visual Studio 2013 or higher is required")
   endif ()
 
   if (CMAKE_CL_64)
@@ -198,7 +209,7 @@
     # if this variable was not set by the user, set it to 3rdparty root's
     # parent dir, which is the normal location for people using our
     # windows-3rd-party repo
-    GET_FILENAME_COMPONENT(MSVC_ROOT_PARENT_DIR ${MSVC_3RDPARTY_ROOT} PATH)
+    get_filename_component(MSVC_ROOT_PARENT_DIR ${MSVC_3RDPARTY_ROOT} DIRECTORY)
     set(BOOST_INCLUDEDIR ${MSVC_ROOT_PARENT_DIR})
     message(STATUS "BOOST_INCLUDEDIR is ${BOOST_INCLUDEDIR}")
   endif()
@@ -271,9 +282,6 @@
 
 else()
     message(STATUS "Using built-in expat code")
-    # XML_STATIC is important to avoid sg_expat_external.h
-    # declaring symbols as declspec(import)
-    add_definitions(-DHAVE_EXPAT_CONFIG_H -DXML_STATIC)
     set(EXPAT_INCLUDE_DIRS
             ${PROJECT_SOURCE_DIR}/3rdparty/expat
             ${PROJECT_BINARY_DIR}/3rdparty/expat)
@@ -292,24 +300,12 @@
 if(ENABLE_RTI)
     find_package(PkgConfig)
     if(PKG_CONFIG_FOUND)
-      SET(ENV{PKG_CONFIG_PATH} "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}")
+      SET(ENV{PKG_CONFIG_PATH} "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/pkgconfig:$ENV{PKG_CONFIG_PATH}")
       pkg_check_modules(RTI hla-rti13)
     endif(PKG_CONFIG_FOUND)
     if(RTI_FOUND)
-      SET(RTI_INCLUDE_DIR "${RTI_INCLUDE_DIRS}")
       message(STATUS "RTI: ENABLED")
     else()
       message(STATUS "RTI: DISABLED")
     endif(RTI_FOUND)
 else()
-    message(STATUS "RTI: DISABLED")
-endif(ENABLE_RTI)
-
-if(ENABLE_GDAL)
-    find_package(GDAL 2.0.0 REQUIRED)
-    if (GDAL_FOUND)
-        include_directories(${GDAL_INCLUDE_DIR})
-    endif(GDAL_FOUND)
-endif(ENABLE_GDAL)
-
-check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)

=== simgear/CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
         bvh
         debug
         embedded_resources
+        emesary
         ephemeris
         io
         magvar
@@ -64,6 +65,9 @@
         set_property(TARGET SimGearScene PROPERTY VERSION   ${SIMGEAR_VERSION})
         set_property(TARGET SimGearScene PROPERTY SOVERSION ${SIMGEAR_SOVERSION})
     endif()
+
+    export_debug_symbols(SimGearCore)
+    export_debug_symbols(SimGearScene)
 else()
     message(STATUS "Library building mode: STATIC LIBRARIES")
 
@@ -114,10 +118,21 @@
     $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
     $<INSTALL_INTERFACE:include>)
 
+# so simgear/simgear_config.h is found
+target_include_directories(SimGearCore BEFORE PUBLIC
+    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
+    $<INSTALL_INTERFACE:include>)
+
 target_include_directories(SimGearCore PUBLIC
   ${Boost_INCLUDE_DIRS} ${ZLIB_INCLUDE_DIR})
 target_include_directories(SimGearCore PRIVATE
   ${EXPAT_INCLUDE_DIRS} ${CURL_INCLUDE_DIRS})
+
+if (NOT SYSTEM_EXPAT)
+    # XML_STATIC is important to avoid sg_expat_external.h
+    # declaring symbols as declspec(import)
+    target_compile_definitions(SimGearCore PRIVATE HAVE_SIMGEAR_EXPAT_CONFIG_H XML_STATIC)
+endif()
 
     install(TARGETS SimGearCore
             EXPORT SimGearTargets
@@ -143,9 +158,10 @@
     endif()
 endif()
 
-
-target_link_libraries(SimGearCore
-    ${ZLIB_LIBRARY}
+# we expose ZLib in some of our headers
+target_link_libraries(SimGearCore PUBLIC ${ZLIB_LIBRARY})
+
+target_link_libraries(SimGearCore PRIVATE
     ${RT_LIBRARY}
     ${DL_LIBRARY}
     ${CMAKE_THREAD_LIBS_INIT}
@@ -154,29 +170,29 @@
     ${WINSOCK_LIBRARY})
 
 if(SYSTEM_EXPAT)
-    target_link_libraries(SimGearCore
-        ${EXPAT_LIBRARIES})
+    target_link_libraries(SimGearCore PRIVATE ${EXPAT_LIBRARIES})
 endif()
 
 if(ENABLE_DNS AND SYSTEM_UDNS)
-    target_link_libraries(SimGearCore
-        ${UDNS_LIBRARIES})
+    target_link_libraries(SimGearCore PRIVATE ${UDNS_LIBRARIES})
 endif()
 
 if(NOT SIMGEAR_HEADLESS)
     target_include_directories(SimGearScene PRIVATE ${PROJECT_SOURCE_DIR}/simgear/canvas/ShivaVG/include)
 
-    target_link_libraries(SimGearScene
+    target_link_libraries(SimGearScene PUBLIC         
         SimGearCore
+        ${OPENSCENEGRAPH_LIBRARIES}
+    )
+
+    target_link_libraries(SimGearScene PRIVATE
         ${ZLIB_LIBRARY}
-        ${OPENSCENEGRAPH_LIBRARIES}
         ${OPENAL_LIBRARY}
         ${OPENGL_LIBRARY}
         ${JPEG_LIBRARY})
 
     if(ENABLE_GDAL)
-        target_link_libraries(SimGearScene
-            ${GDAL_LIBRARIES})
+        target_link_libraries(SimGearScene PRIVATE ${GDAL_LIBRARIES})
     endif()
 
     # only actually needed by canvas/KeyboardEvent.cxx
@@ -188,5 +204,5 @@
     set_property(SOURCE hla/RTI13InteractionClass.cxx hla/RTI13ObjectClass.cxx
         hla/RTI13ObjectInstance.cxx hla/RTI13Federate.cxx
         hla/RTI13FederateFactory.cxx
-        APPEND PROPERTY COMPILE_FLAGS "-I${RTI_INCLUDE_DIR}")
+        APPEND PROPERTY COMPILE_FLAGS "-I${RTI_INCLUDE_DIRS}")
 endif(ENABLE_RTI)

=== simgear/emesary/CMakeLists.txt ===


include (SimGearComponent)

set(HEADERS 
    Emesary.hxx
    INotification.hxx
    IReceiver.hxx
    ITransmitter.hxx
    ReceiptStatus.hxx
    Transmitter.hxx
    notifications.hxx
    )
    
set(SOURCES 
    Emesary.cxx
    )

simgear_component(emesary emesary "${SOURCES}" "${HEADERS}")


if(ENABLE_TESTS)

add_executable(test_emesary test_emesary.cxx)

set_target_properties(test_emesary PROPERTIES
  COMPILE_DEFINITIONS "SRC_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"" )

target_link_libraries(test_emesary ${TEST_LIBS})
add_test(emesary ${EXECUTABLE_OUTPUT_PATH}/test_emesary)


endif(ENABLE_TESTS)

=== simgear/sound/CMakeLists.txt ===
include (SimGearComponent)

set(HEADERS 
    sample.hxx
    sample_group.hxx
    xmlsound.hxx
    soundmgr.hxx
    filters.hxx
    readwav.hxx
    )
    
set(SOURCES 
    sample.cxx
    sample_group.cxx
    xmlsound.cxx
    filters.cxx
    readwav.cxx
    )

if (USE_AEONWAVE)
    set(SOURCES ${SOURCES}
        soundmgr_aeonwave.cxx
        )
else()
    set(SOURCES ${SOURCES}
        soundmgr_openal.cxx
        )
endif()

simgear_scene_component(sound sound "${SOURCES}" "${HEADERS}")

if(ENABLE_TESTS AND ENABLE_SOUND)
    function(create_test TEST_NAME)
        add_executable(${TEST_NAME} ${TEST_NAME}.cxx)
        target_link_libraries(${TEST_NAME} ${SOUND_TEST_LIBS})
        set_target_properties(${TEST_NAME} PROPERTIES
            COMPILE_DEFINITIONS "SRC_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}\"" )
    endfunction()

    set( SOUND_TEST_LIBS ${TEST_LIBS} )

    if (USE_AEONWAVE)
        set(SOUND_TEST_LIBS ${SOUND_TEST_LIBS} ${AAX_LIBRARY})
        create_test(aeonwave_test1)
    else ()
        set(SOUND_TEST_LIBS ${SOUND_TEST_LIBS} ${OPENAL_LIBRARY})
        create_test(openal_test1)
    endif()

    create_test(soundmgr_test)
    create_test(soundmgr_test2)
endif()

=== debian/changelog ===
simgear (1:2020.1.2+dfsg-1) unstable; urgency=medium

  * New upstream version 2020.1.2+dfsg
    - Fixes FTBFS with boost 1.71. Closes: #960424
    - Refresh patches
  * Use debhelper-compat 13
  * Update Standards-Version to 4.5.0, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Tue, 16 Jun 2020 14:43:20 +0200

## simgear 2020.1.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -227,7 +227,7 @@
 endif()
 
 find_package(Boost REQUIRED)
-set (BOOST_CXX_FLAGS "-DBOOST_BIMAP_DISABLE_SERIALIZATION")
+set (BOOST_CXX_FLAGS "-DBOOST_BIMAP_DISABLE_SERIALIZATION -DBOOST_NO_STDLIB_CONFIG")
 include(BoostTestTargets)
 
 if(SIMGEAR_HEADLESS)

=== debian/changelog ===
simgear (1:2020.1.3+dfsg-1) unstable; urgency=medium

  * New upstream version 2020.1.3+dfsg
    - Refresh patches

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 12 Jul 2020 16:44:06 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,12 @@
 Source: simgear
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian FlightGear Crew <team+flightgear@tracker.debian.org>
+Maintainer: Debian FlightGear Crew <team+flightgear@tracker.debian.org>
 Uploaders: Ove Kaaven <ovek@arcticnet.no>,
            Markus Wanner <markus@bluegap.ch>,
            Dr. Tobias Quathamer <toddy@debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libboost-dev,
                libcurl4-gnutls-dev,
                libexpat1-dev,
@@ -19,7 +18,7 @@
                libutfcpp-dev,
                netbase,
                zlib1g-dev
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Homepage: https://home.flightgear.org/
 Vcs-Browser: https://salsa.debian.org/debian/simgear
 Vcs-Git: https://salsa.debian.org/debian/simgear.git

## simgear 2020.3.4+dfsg

=== simgear/debug/CMakeLists.txt ===

include (SimGearComponent)

set(HEADERS debug_types.h 
    logstream.hxx BufferedLogCallback.hxx OsgIoCapture.hxx
    LogCallback.hxx LogEntry.hxx)
set(SOURCES logstream.cxx BufferedLogCallback.cxx
    LogCallback.cxx LogEntry.cxx)

simgear_component(debug debug "${SOURCES}" "${HEADERS}")

=== debian/changelog ===
simgear (1:2020.3.4+dfsg-1) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Let dh_auto_configure pass cross flags to cmake. (Closes: #964997)

  [ Dr. Tobias Quathamer ]
  * New upstream version 2020.3.4+dfsg
    - Refresh patches
  * Update Standards-Version to 4.5.1, no changes needed
  * Use Rules-Requires-Root: no
  * Remove unneeded target 'get-orig-source' from d/rules
  * Update d/copyright

 -- Dr. Tobias Quathamer <toddy@debian.org>  Tue, 08 Dec 2020 12:12:44 +0100

## simgear 2020.3.5+dfsg

=== debian/changelog ===
simgear (1:2020.3.5+dfsg-1) unstable; urgency=medium

  * New upstream version 2020.3.5+dfsg
  * Add patch fix-ftbfs-split_iterator.patch
    - Fixes FTBFS. Closes: #978058

 -- Markus Wanner <markus@bluegap.ch>  Sat, 26 Dec 2020 21:58:34 +0100
